\name{filteringmiRtargets}
\alias{filteringmiRtargets}
\title{Subsetting an expression set using a list of gene which are putative targets for a miRNA}
\description{
  This function subsets the normalized expression set present in the affylmGUI environment
  on the basis of a list of probe set ids extracted on the basis of the predicted gene targets for a microRNA.
  Extraction is based on predicted targets for miRNA in human.
}
\usage{
filteringmiRtargets()
}
\details{
  The function asks to the user to select a file containing probe set ids separated by
  carriage return. The file should contain only one column and no header. 
}
\author{ Raffaele A Calogero }
\note{ 
  In transcriptional studies focusing on genes characterized by specific feature 
  (i.e. transcription factor elements in promoters) the best filtering approach is 
   selecting only those genes linked to the interesting biological feature.
}
\seealso{IPAlistFilter, iqrFilter, intensityFilter}
\keyword{ methods }
