\name{mRNAmiRCor}
\alias{mRNAmiRCor}
\title{Filtering by mean of correlation between expression data and miRNA expression changes}
\description{
  This function extract the subset of gene ids which are associated to the changes of expression on putative miRNA targets upon 
  perturbation of miR expression.
}
\usage{
mRNAmiRCor()
}
\details{
   To run this analysis a time course experiment suitable for maSigPro analysis is needed. Expression data need to have
   at least 3 time points for samples transfected with a scrambled and with an Antagomir or a Mimic. 
   The expression changes at the same time points used for microarray data need to be measured also for miRNA. 
   miRNA expression data need to be saved as table delimited file with two columns: column Name, 
   which has to be organized exactly as the target file Name column,and a column named Value
   with expression of miRNA, e.g. deltaCt.
   Target file for mRNA data need to be organized as for maSigPro time course analysis.
   Output is a three column (gene level id, miRNA-mRNA correlation, mRNA untreated - mRNA treated correlation) 
   tab delimited file with gene IDs and correlation coefficient between mRNA profile and miRNA profile upon 
   treatment with antagomir, i.e. mRNA expression should rise due to the reduction of miRNA expression, 
   or mimics, i.e. mRNA expression should be reduced due to the over-expression of the specific miRNA.
}
\author{ Raffaele A Calogero }
\seealso{IPAlistFilter, iqrFilter, intensityFilter}
\keyword{ methods }
