\name{runningJetta}
\alias{runningJetta}
\title{graphical interface to MADS/jetta R library.}
\description{
  MADS, which stands for Microarray Analysis of Differential Splicing, is a tool to 
  identify differential alternative splicing by exon array. The principle of MADS is 
  to increase the precision of exon-level and gene-level expression estimates by 
  correcting, as much as possible, noise in observed probe intensities due to 
  background and cross-hybridization. 
  MADS incorporates a series of novel algorithms motivated by the probe-rich design 
  of exon-tiling arrays, such as background correction, iterative probe selection and 
  removal of sequence-specific cross-hybridization to off-target transcripts. 
  MADS was published in RNA,2008,14(8): 1470-1479.
  Junction and Exon array Toolkit for Transcriptome Analysis (JETTA) is compacted version of MADS.
}
\usage{runningJetta()}
\details{
 Expression indexes are calculated as the order of Background Correction, 
 Normalization and Summarization. 
 In the Summarization step, background corrected and normalized probe intensities 
 of a meta probeset are summarized to expression of the meta probeset. 
 Meta probesets can be defined as gene/transcript clust/exon level.

Background Correction
JETTA estimates background signal using background probes and subtracts it from the probe intensity. 
If the probe intensity is less than the estimated background signal, the background 
subtracted signal is truncated to 1. 
Estimation of background signal is based on several models:
    Median GC: median of background probe signal of the same GC counts
    MAT: linear model of probe sequence with 80 parameters. see Kapur et al, 2007 

Normalization
Normalization of JETTA is done for core probes defined in probeset annotation file. 
If the PSA file is not specified, it considers all probes in the MPS files as core probes.
    Median scaling: scaling each array so that its median is 100
    Quantile: all probes of the same signal quantile have the same signal 

Summarization
    LiWong model: multiplication model of expression and probe effect, see Li and Wong, 2001
    Probe selection: select probes based on cross-array correlation of signal. see Xing et al, 2006
    Median-polish 

Alternative Splicing Detection
Detecting alternatively expressed PSR/Exon between two sample groups based on 
background corrected and normalized probe intensities. It has several criteria to 
filter out transcript clusts and probes from the analysis.
    TC expression level: excluding low-expressed transcript clusts
    TC expression fold change: excluding transcript clusts which have big fold change between two groups
    Extreme probe signal: excluding probes of which signal is extremely high
    Cross-hybridized probes: excluding cross hybridized probes, currently pre-calculated results are needed 



}
\author{jseok@stanford.edu}
\keyword{utilities}
