\title{TuxedoSuite}

\name{TuxedoSuite}
\alias{tophat}
\alias{createDir}
\alias{cufflinks}
\alias{cuffmerge}
\alias{cuffdiff}
\alias{geneDiff}
\alias{isoDiff}
\alias{cdsDiff}
\alias{chooseInDir}
\alias{chooseOutDir}

\description{TuxedoSuite contains a set of functions to run tophat, cufflinks, cuffmerge, cuffdiff and to extract gene,
geneDiff, isoforms, isoDiff, and CDS, cdsDiff, differentially expressed between two experimental conditions. The present implementation
works only on MAC and Linux, due to the absence of a windows implementation of the tuxedo suite.
tophat, cufflinks, cuffmerge and cuffdiff create the line command to execute the correponding program and all programs are run in background, since they might require quite a lot of computation time. One differential expression is obtained geneDiff, isoDiff and cdsDiff can be used to extract respectively differentially expressed genes, isoforms and CDSs}
\usage{
tophat()
createDir()
cufflinks()
cuffmerge()
cuffdiff()
geneDiff()
isoDiff()
cdsDiff()
chooseInDir()
chooseOutDir()
}

\details{
tophat, cufflinks, samtools and bowtie need to be installed in the system and their folder installation inserted in the PATH variable. Also the genome of interest, as fasta file and as bowtie indexed files need to be previously installed together with a GTF file containing known annotations for the genome of interest.
To run the pipeline a target file is needed. createDir generates folders, with the name extracted from the Name column in the target file. In each of these folders tophat will create the files used by cufflinks, cuffmerge, cuffdiff. cuffdiff will create a folder in which differentially expressed data are saved. Access to those data is done using the cummeRbund package.
}
\author{Raffaele A Calogero}
\keyword{IO}
